(function(e, a) { for(var i in a) e[i] = a[i]; if(a.__esModule) Object.defineProperty(e, "__esModule", { value: true }); }(exports,
/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ([
/* 0 */
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.DotCompleteProvider = exports.activate = void 0;
const coc_nvim_1 = __webpack_require__(1);
function activate(context) {
    return __awaiter(this, void 0, void 0, function* () {
        const { subscriptions } = context;
        const config = coc_nvim_1.workspace.getConfiguration('dot-complete');
        subscriptions.push(coc_nvim_1.languages.registerCompletionItemProvider('coc-dot-complete', config.get('shortcut'), null, new DotCompleteProvider(), ["."], config.get('priority'), []));
    });
}
exports.activate = activate;
class DotCompleteProvider {
    constructor() { }
    provideCompletionItems(document, position) {
        const doc = coc_nvim_1.workspace.getDocument(document.uri);
        if (!doc)
            return [];
        const wordRange = doc.getWordRangeAtPosition(coc_nvim_1.Position.create(position.line, position.character - 2));
        if (!wordRange)
            return [];
        const preWord = document.getText(wordRange);
        return this.gatherWords()
            .filter(word => word.indexOf(preWord) < 0 &&
            preWord.indexOf(word) < 0)
            .map(word => ({
            "label": `${word}`,
            "kind": coc_nvim_1.CompletionItemKind.Text,
            "insertText": `${word}`
        }));
    }
    gatherWords() {
        const words = [];
        coc_nvim_1.workspace.documents.forEach(document => {
            if (document['isIgnored'])
                return;
            for (const word of document['words']) {
                words.push(word);
                for (const word_no_underscore of word.split('_')) {
                    if (!words.includes(word_no_underscore) && word_no_underscore.length >= 3) {
                        words.push(word_no_underscore);
                    }
                }
            }
        });
        return words;
    }
}
exports.DotCompleteProvider = DotCompleteProvider;


/***/ }),
/* 1 */
/***/ ((module) => {

module.exports = require("coc.nvim");;

/***/ })
/******/ 	]);
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	// module exports must be returned from runtime so entry inlining is disabled
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })()

));